clang-tools 6.0.0

Functions
clang::tidy::utils::type_traits Namespace Reference

## Functions
llvm::Optional< bool > | isExpensiveToCopy (QualType Type, const ASTContext &Context)
| Returns `true` if `Type` is expensive to copy. More...
bool | recordIsTriviallyDefaultConstructible (const RecordDecl &RecordDecl, const ASTContext &Context)
| Returns `true` if `RecordDecl` is trivially default constructible. More...
bool | isTriviallyDefaultConstructible (QualType Type, const ASTContext &Context)
| Returns `true` if `Type` is trivially default constructible. More...
bool | hasNonTrivialMoveConstructor (QualType Type)
| Returns true if `Type` has a non-trivial move constructor. More...
bool | hasNonTrivialMoveAssignment (QualType Type)
| Return true if `Type` has a non-trivial move assignment operator. More...

## Function Documentation

## ◆ hasNonTrivialMoveAssignment()

bool clang::tidy::utils::type_traits::hasNonTrivialMoveAssignment | ( | QualType | Type | ) |

Return true if `Type` has a non-trivial move assignment operator.

Definition at line 140 of file TypeTraits.cpp.

Referenced by clang::tidy::performance::UnnecessaryValueParamCheck::check().

## ◆ hasNonTrivialMoveConstructor()

bool clang::tidy::utils::type_traits::hasNonTrivialMoveConstructor | ( | QualType | Type | ) |

Returns true if `Type` has a non-trivial move constructor.

Definition at line 134 of file TypeTraits.cpp.

Referenced by clang::tidy::performance::UnnecessaryValueParamCheck::check().

## ◆ isExpensiveToCopy()

llvm::Optional< bool > clang::tidy::utils::type_traits::isExpensiveToCopy | ( | QualType | Type,
|  | const ASTContext & | Context
| ) |  |

Returns `true` if `Type` is expensive to copy.

Definition at line 42 of file TypeTraits.cpp.

Referenced by clang::tidy::matchers::AST_MATCHER(), and clang::tidy::performance::ForRangeCopyCheck::check().

## ◆ isTriviallyDefaultConstructible()

bool clang::tidy::utils::type_traits::isTriviallyDefaultConstructible | ( | QualType | Type,
|  | const ASTContext & | Context
| ) |  |

Returns `true` if `Type` is trivially default constructible.

Definition at line 88 of file TypeTraits.cpp.

Referenced by clang::tidy::cppcoreguidelines::isEmpty().

## ◆ recordIsTriviallyDefaultConstructible()

bool clang::tidy::utils::type_traits::recordIsTriviallyDefaultConstructible | ( | const RecordDecl & | RecordDecl,
|  | const ASTContext & | Context
| ) |  |

Returns `true` if `RecordDecl` is trivially default constructible.

Definition at line 51 of file TypeTraits.cpp.

Referenced by clang::tidy::matchers::AST_MATCHER().